;********************************
;Project:  MCU	    *
;Version: 1.2                   *
;File name: msuoff_2.asm        * 
;Chip: ATTiny15L                *
;Clock frequency: 1,6 MHz       *
;Autor:            * 
;********************************
/*  .
      .
     (  ), 
       2 ,   PB2(INT0).
    INT0   
   , .. 
   ,   .
   
   ,   .  
*/
;================================
.include "tn15def.inc"
;================================
;
.def temp = r16				; 
.def RegDEL_1 = r17			;  	
.def RegDEL_2 = r18			;  
.def RegDEL_3 = r20			;  
.def RegDEL_4 = r19			;  
.equ Work_LED = PB1			;,  
.equ MCU_ON = PB0			;,   
.equ MCU_OFF = PB2			;  
.cseg
;================================
; 
.org 0			rjmp INIT			;  
.org INT0addr 	rjmp INTERRUPT_0	;   INT0	
.org OVF0addr	rjmp TIMER0_Overflow;     0	
.org 10								;    	
;================================
;
INIT:
		ldi temp,0b00000011	;PB2 - , PB0, PB1 - 
		out DDRB,temp	
		ser temp			;   PB2
		out PORTB,temp		; .1    PB0, PB1 (MCU  , HL1 )
		ldi temp,1<<PSR0
		out SFIOR,temp		;   T0
		ldi temp,1<<TOIE0
		out TIMSK,temp		;    T0
		ldi temp,1<<TOV0
		out TIFR,temp		;    T0
		sei					;  
		ldi temp,1<<CS02
		out TCCR0,temp		;  T0    256
		ldi temp,(0<<ISC00|1<<ISC01)
		out MCUCR,temp		;      INT0
		ldi temp,1<<INT0
		out GIMSK,temp		;   INT0 (  PB2)
;================================
;  
START:
		clr RegDEL_1		;  
Work_1:
		cpi RegDEL_1,6		;   ,    240  		
		brne Work_1			;  , 	
		cbi PORTB,Work_LED	; ,   
		clr RegDEL_1		;   	
Work_2:		
		cpi RegDEL_1,6		;   ,    240 
		brne Work_2			;  , 
		sbi PORTB,Work_LED	; ,   
		clr RegDEL_1		;    
		rjmp Work_1
;;================================
; 
;   INT0
INTERRUPT_0:
		in temp,SREG 		;   SREG 
		sbi PORTB,Work_LED	;  
		ldi RegDEL_4,40		;    2  (40   50 )
		ldi RegDEL_3,100	;    50  (100   0,5 )
Work_4:						
		ldi RegDEL_2,200	;    0,5 
Work_3:						;4   0,625   200 = 500 					
		nop					;  1 
		subi RegDEL_2,1		;  1 
		brne Work_3			;  2 
		subi RegDEL_3,1		
		brne Work_4
Button_press:		
		sbic PINB,MCU_OFF	;  / , 
		rjmp Int_Out_0		
		ldi RegDEL_3,100	;    50  (100   0,5 )
Work_5:						;4   0,625   200 = 500 
		ldi RegDEL_2,200	;    0,5 
Work_6:
		nop					;  1 
		subi RegDEL_2,1		;  1 
		brne Work_6			;  2 
		subi RegDEL_3,1		
		brne Work_5
		subi RegDEL_4,1
		cpi RegDEL_4,0
		brne Button_press	; 2   ,   
		ldi temp,0<<CS02	; 2     / , 
		out TCCR0,temp		;  T0
		clr temp			;  
		out PORTB,temp		;    
Int_Out_0:					;  /  ,    
		out SREG,temp		;   SREG 
		reti
;    T0
TIMER0_Overflow:
		in temp,SREG 		;   SREG 
		inc RegDEL_1		; RegDEL_1 -  T0  (  40 )
		out SREG,temp		;   SREG 
		reti
;================================
; 
;================================
